﻿/* tslint:disable */
//----------------------
// <auto-generated>
//     Generated using the NSwag toolchain v12.0.1.0 (NJsonSchema v9.12.3.0 (Newtonsoft.Json v11.0.0.0)) (http://NSwag.org)
// </auto-generated>
//----------------------
// ReSharper disable InconsistentNaming

export module nir {

/** Object that stores National Incomes Register Earnings Payment Reports. */
export interface EarningsPayment {
    /** Delivery data from IR Wage Report. */
    deliveryData?: DeliveryData | null;
    /** Salaxy data that can't be stored in Earnings Payment Report */
    info?: EarningsPaymentExtensions | null;
    /** Validation for the Earnings Payment Report */
    validation?: ApiValidation | null;
    /** Status of the Earnings Payment Report. */
    status?: EarningsPaymentStatus | null;
    /** Identifier of the object. */
    id?: string | null;
    /** The date when the object was created. */
    createdAt?: string | null;
    /** The time when the object was last updated.
Typically this should be a logical update by user (UserUpdatedAt in DTO), not technical updates. */
    updatedAt?: string | null;
    /** Owner ID for this data */
    owner?: string | null;
    /** Indication that for the currently logged-in account, the data is generally read-only. */
    isReadOnly?: boolean | null;
    /** Partner service that has be used in modifying the object. */
    partner?: string | null;
}

export interface DeliveryData {
    timestamp?: string | null;
    source?: string | null;
    deliveryDataType?: DeliveryDataType | null;
    deliveryId?: string | null;
    faultyControl?: FaultyControl | null;
    productionEnvironment?: boolean | null;
    deliveryDataOwner?: Id | null;
    deliveryDataCreator?: Id | null;
    deliveryDataSender?: Id | null;
    paymentPeriod?: PaymentPeriod | null;
    contactPersons?: ContactPerson[] | null;
    payer?: Payer | null;
    reports?: Report[] | null;
}

/** Salaxy data that can't be stored in earnings payment report */
export interface EarningsPaymentExtensions {
    /** Worker tax card */
    workerTaxCard?: TaxCardSnapshot | null;
    /** Calculation used to generate this WageReport */
    calculationId?: string | null;
    /** Employer's Id */
    employerId?: string | null;
    /** Worker's Id */
    workerId?: string | null;
}

/** Common base class / interface for data validation. */
export interface ApiValidation {
    /** If true, the data is valid - no errors. */
    isValid?: boolean | null;
    /** If true, has required fields missing data. */
    hasAllRequiredFields?: boolean | null;
    /** Validation errors on invalid field values.
Note that required fields missing error messages are not here. Only the invalid values. */
    errors?: ApiValidationError[] | null;
}

export interface Id {
    type?: IdType | null;
    code?: string | null;
    countryCode?: string | null;
    countryName?: string | null;
}

export interface PaymentPeriod {
    paymentDate?: string | null;
    startDate?: string | null;
    endDate?: string | null;
}

export interface ContactPerson {
    name?: string | null;
    telephone?: string | null;
    email?: string | null;
    responsibilityCode?: ResponsibilityCode | null;
}

export interface Payer {
    payerIds?: Id[] | null;
    payerBasic?: PayerBasic | null;
    address?: Address | null;
    subOrgs?: SubOrg[] | null;
    payerOther?: PayerOther | null;
    substitutePayer?: SubstitutePayer | null;
}

export interface Report {
    reportData?: ReportData | null;
    incomeEarner?: IncomeEarner | null;
    transactions?: Transaction[] | null;
}

/** Basic information about the taxcard: This object has the infromation printed in SalarySlip etc. but not the full salaries paid to the taxcard etc. */
export interface TaxCardSnapshot {
    /** Year that the tax card is valid for. Typically this means from February of this year to January of the following. */
    forYear: number;
    /** Issue date off the tax card. */
    date?: string | null;
    /** Tax percent as percent. I.e. for 50% set 50, not 0.5. */
    taxPercent?: number | null;
    /** Income up to which the TaxPercent can be used.
Any income above the limit is taxed with ExcessTaxPercent. */
    incomeLimit?: number | null;
    /** Tax percentage that is used in calculating the widthholding tax for the part of income above the IncomeLimit. */
    taxPercent2?: number | null;
    /** Type of tax card. */
    type?: TaxCardSnapshotType | null;
    /** Uri to the file copy of the tax card.
Set by the system as part of the upload process, do not change in the API though it may be technically possible. This may have unintended results. */
    fileUri?: string | null;
    /** Uri to the preview image of the tax card.
Set by the system as part of the upload process, do not change in the API though it may be technically possible. This may have unintended results. */
    previewUri?: string | null;
}

/** Validation errors used in API output. */
export interface ApiValidationError {
    /** Full path to Name of the property / field (Member name in JSON).
This may be null/empty for type General. */
    key?: string | null;
    /** High level type: Specifies the relation to object and its Member. */
    type: ApiValidationErrorType;
    /** Validation error message in the requested language. */
    msg: string;
    /** Some error providers may have a unique technical code for error or validator */
    code?: string | null;
}

export interface PayerBasic {
    missingId?: boolean | null;
    companyName?: string | null;
    lastName?: string | null;
    firstName?: string | null;
    birthDate?: string | null;
    language?: Language | null;
}

export interface Address {
    co?: string | null;
    street?: string | null;
    poBox?: string | null;
    postalCode?: string | null;
    postOffice?: string | null;
    countryCode?: string | null;
    countryName?: string | null;
}

export interface SubOrg {
    type?: number | null;
    code?: string | null;
}

export interface PayerOther {
    payerTypes?: PayerType[] | null;
}

export interface SubstitutePayer {
    acts?: boolean | null;
    employerId?: Id | null;
    employerName?: string | null;
    wageSec?: boolean | null;
}

export interface ReportData {
    actionCode?: ActionCode | null;
    irReportId?: string | null;
    reportId?: string | null;
    reportVersion?: number | null;
}

export interface IncomeEarner {
    incomeEarnerIds?: Id[] | null;
    incomeEarnerBasic?: IncomeEarnerBasic | null;
    addresses?: TypedAddress[] | null;
    subOrgs?: SubOrg[] | null;
    employment?: Employment | null;
    professions?: Profession[] | null;
    employmentRegs?: EmploymentReg[] | null;
    placeOfBusiness?: PlaceOfBusiness | null;
    pensionInsurance?: PensionInsurance | null;
    accidentInsurance?: AccidentInsurance | null;
    insuranceExceptions?: ExceptionCode[] | null;
    incomeEarnerOther?: IncomeEarnerOther | null;
}

export interface Transaction {
    transactionBasic?: TransactionBasic | null;
    insuranceData?: TransactionInclusion[] | null;
    earningPeriods?: EarningPeriod[] | null;
    unitWages?: UnitWage[] | null;
    carBenefit?: CarBenefit | null;
    mealBenefit?: MealBenefit | null;
    otherBenefit?: BenefitCode[] | null;
    recoveryData?: RecoveryData | null;
    dailyAllowance?: AllowanceCode[] | null;
    kmAllowance?: KmAllowance | null;
}

export interface IncomeEarnerBasic {
    missingId?: boolean | null;
    companyName?: string | null;
    lastName?: string | null;
    firstName?: string | null;
    birthDate?: string | null;
    gender?: Gender | null;
}

export interface TypedAddress {
    addressType?: AddressType | null;
    co?: string | null;
    street?: string | null;
    poBox?: string | null;
    postalCode?: string | null;
    postOffice?: string | null;
    countryCode?: string | null;
    countryName?: string | null;
}

export interface Employment {
    employed?: boolean | null;
    employmentCode?: EmploymentCode | null;
    termCode?: TermCode | null;
    partTime?: number | null;
    hoursPerWeek?: number | null;
    paymentTypes?: PaymentType[] | null;
    employmentPeriods?: Period[] | null;
    employmentEndings?: EmploymentEnding[] | null;
}

export interface Profession {
    type?: ProfessionType | null;
    code?: string | null;
    title?: string | null;
}

export interface EmploymentReg {
    type?: number | null;
    code?: string | null;
}

export interface PlaceOfBusiness {
    code?: string | null;
    street?: string | null;
    postalCode?: string | null;
    postOffice?: string | null;
    countryCode?: string | null;
    countryName?: string | null;
}

export interface PensionInsurance {
    pensionActCode?: PensionActCode | null;
    pensionProvIdCode?: PensionProvIdCode | null;
    pensionPolicyNo?: string | null;
}

export interface AccidentInsurance {
    accInsProvId?: Id | null;
    accInsPolicyNo?: string | null;
}

export interface IncomeEarnerOther {
    cbaCode?: number | null;
    incomeEarnerTypes?: number[] | null;
    payments?: Payment[] | null;
}

export interface TransactionBasic {
    transactionCode?: number | null;
    amount?: number | null;
    noMoney?: boolean | null;
    oneOff?: boolean | null;
    unjustEnrichment?: boolean | null;
    recovery?: boolean | null;
}

export interface TransactionInclusion {
    insuranceCode?: InsuranceCode | null;
    included?: boolean | null;
}

export interface EarningPeriod {
    startDate?: string | null;
    endDate?: string | null;
}

export interface UnitWage {
    unitPrice?: number | null;
    unitAmount?: number | null;
    unitCode?: WageUnitCode | null;
}

export interface CarBenefit {
    carBenefitCode?: CarBenefitCode | null;
    ageGroupCode?: AgeGroupCode | null;
    kilometers?: number | null;
}

export interface MealBenefit {
    taxValue?: boolean | null;
}

export interface RecoveryData {
    recoveryDate?: string | null;
    withhold?: number | null;
    origPaymentPeriods?: OrigPaymentPeriod[] | null;
}

export interface KmAllowance {
    kilometers?: number | null;
}

export interface Period {
    startDate?: string | null;
    endDate?: string | null;
}

export interface EmploymentEnding {
    type?: EmploymentEndingType | null;
    code?: string | null;
}

export interface Payment {
    paymentType?: RefPaymentType | null;
    paymentRef?: string | null;
    paymentSpecifier?: string | null;
}

export interface OrigPaymentPeriod {
    paymentDate?: string | null;
    startDate?: string | null;
    endDate?: string | null;
}

/** Vero.fi income types and control rules */
export interface IncomeTypeCode {
    code?: number | null;
    nameEn?: string | null;
    nameFi?: string | null;
    nameSv?: string | null;
    pensionInsurance?: boolean | null;
    accidentInsurance?: boolean | null;
    unemploymentInsurance?: boolean | null;
    healthInsurance?: boolean | null;
    insuranceInformationAllowed?: boolean | null;
    transactionCode?: TransactionCode | null;
}

/** ActionCode enumeration */
export enum ActionCode {
    NewReport = "newReport",
    ReplacementReport = "replacementReport",
}

/** AddressType enumeration */
export enum AddressType {
    AddressInHomeCountry = "addressInHomeCountry",
    AddressInTheCountryOfWork = "addressInTheCountryOfWork",
}

/** AgeGroupCode enumeration */
export enum AgeGroupCode {
    A = "a",
    B = "b",
    C = "c",
    U = "u",
}

/** AllowanceCode enumeration */
export enum AllowanceCode {
    MealAllowance = "mealAllowance",
    PartialDailyAllowance = "partialDailyAllowance",
    FullDailyAllowance = "fullDailyAllowance",
    InternationalDailyAllowance = "internationalDailyAllowance", 
}

/** BenefitCode enumeration */
export enum BenefitCode {
    AccommodationBenefit = "accommodationBenefit",
    TelephoneBenefit = "telephoneBenefit",
    MealBenefit = "mealBenefit",
    OtherBenefits = "otherBenefits",
}

/** CarBenefitCode enumeration */
export enum CarBenefitCode {
    LimitedCarBenefit = "limitedCarBenefit",
    FullCarBenefit = "fullCarBenefit",
}

/** DeliveryDataType enumeration */
export enum DeliveryDataType {
    EarningsPaymentReports = "earningsPaymentReports",
}

/** EmploymentCode enumeration */
export enum EmploymentCode {
    FullTime = "fullTime",
    PartTime = "partTime",
    NotAvailable = "notAvailable",
}

/** EmploymentEndingCode enumeration */
export enum EmploymentEndingCode {
    EmployeesResignation = "employeesResignation",
    Other = "other",
    TerminationGroundsRelatedToEmployeesPerson = "terminationGroundsRelatedToEmployeesPerson",
    FinancialAndProductionRelatedGrounds = "financialAndProductionRelatedGrounds",
    JointAgreement = "jointAgreement",
    Retirement = "retirement",
    TerminationOfaFixedTermEmployment = "terminationOfaFixedTermEmployment",
}

/** EmploymentEndingType enumeration */
export enum EmploymentEndingType {
    KevaCodes = "kevaCodes",
    BankOfFinlandCodes = "bankOfFinlandCodes",
    IncomesRegisterCodes = "incomesRegisterCodes",
}

/** ExceptionCode enumeration */
export enum ExceptionCode {
    NoObligationToSocialInsurance = "noObligationToSocialInsurance",
    NoObligationToHealthInsurance = "noObligationToHealthInsurance",
    NoObligationToEarningsRelatedPensionInsurance = "noObligationToEarningsRelatedPensionInsurance",
    NoObligationToAccidentAndOccupationalDiseaseInsurance = "noObligationToAccidentAndOccupationalDiseaseInsurance",
    NoObligationToUnemploymentInsurance = "noObligationToUnemploymentInsurance",
    NotSubjectToSocialInsurance = "notSubjectToSocialInsurance",
    NotSubjectToEarningsRelatedPensionInsurance = "notSubjectToEarningsRelatedPensionInsurance",
    NotSubjectToAccidentAndOccupationalDiseaseInsurance = "notSubjectToAccidentAndOccupationalDiseaseInsurance",
    NotSubjectToUnemploymentInsurance = "notSubjectToUnemploymentInsurance",
    NotSubjectToHealthInsurance = "notSubjectToHealthInsurance",
    VoluntaryEarningsRelatedPensionInsurance = "voluntaryEarningsRelatedPensionInsurance",
}

/** FaultyControl enumeration */
export enum FaultyControl {
    OnlyInvalidItems = "onlyInvalidItems",
    EntireRecordIsRejected = "entireRecordIsRejected",
}

/** Gender enumeration */
export enum Gender {
    Female = "female",
    Male = "male",
}

/** IdType enumeration */
export enum IdType {
    BusinessId = "businessId",
    PersonalIdentificationNumber = "personalIdentificationNumber",
    Vat = "vat",
    Giin = "giin",
    TaxIdentificationNumber = "taxIdentificationNumber",
    FinnishTradeRegistrationNumber = "finnishTradeRegistrationNumber",
    ForeignBusinessRegistrationNumber = "foreignBusinessRegistrationNumber",
    ForeignPersonalIdentificationNumber = "foreignPersonalIdentificationNumber",
    Other = "other",
}

/** InsuranceCode enumeration */
export enum InsuranceCode {
    SubjectToSocialInsuranceContributions = "subjectToSocialInsuranceContributions",
    SubjectToEarningsRelatedPensionInsuranceContribution = "subjectToEarningsRelatedPensionInsuranceContribution",
    SubjectToHealthInsuranceContribution = "subjectToHealthInsuranceContribution",
    SubjectToUnemploymentInsuranceContribution = "subjectToUnemploymentInsuranceContribution",
    SubjectToAccidentInsuranceAndOccupationalDiseaseInsuranceContribution = "subjectToAccidentInsuranceAndOccupationalDiseaseInsuranceContribution",
}

/** Language enumeration */
export enum Language {
    Finnish = "finnish",
    Swedish = "swedish",
    English = "english",
}

/** PayerType enumeration */
export enum PayerType {
    PublicSector = "publicSector",
    Household = "household",
    TemporaryEmployer = "temporaryEmployer",
    ForeignEmployer = "foreignEmployer",
    State = "state",
    UnincorporatedStateEnterpriseOrGovernmentalInstitution = "unincorporatedStateEnterpriseOrGovernmentalInstitution",
    SpecialisedAgency = "specialisedAgency",
    ForeignGroupCompany = "foreignGroupCompany",
}

/** PaymentType enumeration */
export enum PaymentType {
    Monthly = "monthly",
    Hourly = "hourly",
    ContractPay = "contractPay",
}

/** PensionActCode enumeration */
export enum PensionActCode {
    EmployeesEarningsRelatedPensionInsurance = "employeesEarningsRelatedPensionInsurance",
    PensionInsuranceForFarmers = "pensionInsuranceForFarmers",
    PensionInsuranceForTheSelfEmployed = "pensionInsuranceForTheSelfEmployed",
}

/** PensionProvIdCode enumeration */
export enum PensionProvIdCode {
    None = "none",
    Alandia = "alandia",
    Ilmarinen = "ilmarinen",
    Elo = "elo",
    Varma = "varma",
    Veritas = "veritas",
    Etera = "etera",
    Apteekkien ="apteekkien",
    Verso = "verso"
}

/** ProfessionType enumeration */
export enum ProfessionType {
    StatisticsFinland = "statisticsFinland",
    Keva = "keva",
    BankOfFinland = "bankOfFinland",
    Trafi = "trafi",
}

/** RefPaymentType enumeration */
export enum RefPaymentType {
    EarningsRelatedPensionProvider = "earningsRelatedPensionProvider",
}

/** RemunerationCode enumeration */
export enum RemunerationCode {
    DailyAllowance = "dailyAllowance",
    AccommodationBenefit = "accommodationBenefit",
    CarBenefit = "carBenefit",
    OtherBenefit = "otherBenefit",
}

/** ResponsibilityCode enumeration */
export enum ResponsibilityCode {
    ContentIssues = "contentIssues",
    TechnicalIssues = "technicalIssues",
}

/** TermCode enumeration */
export enum TermCode {
    UntilFurtherNotice = "untilFurtherNotice",
    FixedTerm = "fixedTerm",
}

/** TransactionCode enumeration */
export enum TransactionCode {
    Unknown = "unknown",
    Ignored = "ignored",
    TimeRatePay = "timeRatePay",
    EveningWorkCompensation = "eveningWorkCompensation",
    EveningShiftAllowance = "eveningShiftAllowance",
    SaturdayPay = "saturdayPay",
    HolidayBonus = "holidayBonus",
    OtherCompensation = "otherCompensation",
    SundayWorkCompensation = "sundayWorkCompensation",
    CompensationForAccruedTimeOff = "compensationForAccruedTimeOff",
    ContractPay = "contractPay",
    AnnualHolidayCompensation = "annualHolidayCompensation",
    OverTimeCompensation = "overTimeCompensation",
    NightWorkAllowance = "nightWorkAllowance",
    NightShiftCompensation = "nightShiftCompensation",
    AccommodationBenefit = "accommodationBenefit",
    MealAllowance = "mealAllowance",
    CarBenefit = "carBenefit",
    KilometreAllowanceTaxExempt = "kilometreAllowanceTaxExempt",
    OtherTaxableBenefitForEmployees = "otherTaxableBenefitForEmployees",
    OtherFringeBenefit = "otherFringeBenefit",
    TelephoneBenefit = "telephoneBenefit",
    DailyAllowance = "dailyAllowance",
    MealBenefit = "mealBenefit",
    NonWageCompensationForWork = "nonWageCompensationForWork",
    TaxableReimburementOfExpenses = "taxableReimburementOfExpenses",
    PrivateDayCareAllowanceWages = "privateDayCareAllowanceWages",
    PrivateDayCareAllowanceNonWage = "privateDayCareAllowanceNonWage",
    WithholdingTax = "withholdingTax",
    WagesPaid = "wagesPaid",
    OtherItemDeductibleFromNetWage = "otherItemDeductibleFromNetWage",
    NetWage = "netWage",
    EmployeesPensionInsuranceContribution = "employeesPensionInsuranceContribution",
    EmployeesUnemploymentInsuranceContribution = "employeesUnemploymentInsuranceContribution",
    Distraint = "distraint",
    DeductionBeforeWithholding = "deductionBeforeWithholding",
    WagesPaidBySubstitutePayerIncludingSocialInsurance = "wagesPaidBySubstitutePayerIncludingSocialInsurance",

    WagesPaidBySubstitutePayerIncludingEarningsRelatedPensionInsurance = "wagesPaidBySubstitutePayerIncludingEarningsRelatedPensionInsurance",

    WagesPaidBySubstitutePayerIncludingUnemploymentInsurance = "wagesPaidBySubstitutePayerIncludingUnemploymentInsurance",

    WagesPaidBySubstitutePayerIncludingAccidentAndOccupationalDiseaseInsurance = "wagesPaidBySubstitutePayerIncludingAccidentAndOccupationalDiseaseInsurance",

    WagesPaidBySubstitutePayerIncludingHealthInsurance = "wagesPaidBySubstitutePayerIncludingHealthInsurance",

    KilometreAllowanceTaxable = "kilometreAllowanceTaxable",

    LectureFee = "lectureFee",
    KilometreAllowancePaidByNonProfitOrganisation = "kilometreAllowancePaidByNonProfitOrganisation"
}

/** WageUnitCode enumeration */
export enum WageUnitCode {
    Hour = "hour",
    Day = "day",
    Week = "week",
    Period = "period",
}

export enum EarningsPaymentStatus {
    New = "new",
    Succeeded = "succeeded",
    Canceled = "canceled",
    Error = "error",
}

export enum TaxCardSnapshotType {
    Example = "example",
    NoTaxCard = "noTaxCard",
    SideIncome = "sideIncome",
    NoTaxPrepayment = "noTaxPrepayment",
    TaxCardA = "taxCardA",
    TaxCardB = "taxCardB",
    Freelancer = "freelancer",
    Steps = "steps",
    Others = "others",
}

export enum ApiValidationErrorType {
    General = "general",
    Required = "required",
    Invalid = "invalid",
}

}
